<?php
/**
*
* @ DecodeTMT (PHP Decompiler)

* @	Version			:	1.0.0
* @	Author			:	Magd Almuntaser(TTMTT)
* @	Release on		:	02.20.2013
* @	Official site	:	www.liioiil.com
*
*/               

	class resize {
		protected $image = null;
		protected $width = null;
		protected $height = null;
		protected $imageResized = null;

		function __construct($fileName) {
			$this->image = $this->openImage( $fileName );

			if ($this->image === false) {
				return false;
			}

			$this->width = imagesx( $this->image );
			$this->height = imagesy( $this->image );
			return true;
		}

		function openImage($file) {
			$info = getimagesize( $file );
			$mime = $info['mime'];
			switch ($mime) {
				case 'image/jpg': {
				}

				case 'image/jpeg': {
					$img = imagecreatefromjpeg( $file );
					break;
				}

				case 'image/gif': {
					$img = imagecreatefromgif( $file );
					break;
				}

				case 'image/png': {
					$img = imagecreatefrompng( $file );
					break;
				}

				default: {
					$img = false;
					break;
				}
			}

			return $img;
		}

		function resizeImage($newWidth, $newHeight, $option = 'auto') {
			if (( $this->width < $newWidth && $this->height < $newHeight )) {
				$newWidth = $this->width;
				$newHeight = $this->height;
			}

			$optionArray = $this->getDimensions( $newWidth, $newHeight, $option );
			$optimalWidth = $optionArray['optimalWidth'];
			$optimalHeight = $optionArray['optimalHeight'];
			$this->imageResized = imagecreatetruecolor( $optimalWidth, $optimalHeight );
			imagecopyresampled( $this->imageResized, $this->image, 0, 0, 0, 0, $optimalWidth, $optimalHeight, $this->width, $this->height );

			if ($option == 'crop') {
				$this->crop( $optimalWidth, $optimalHeight, $newWidth, $newHeight );
			}

		}

		function getDimensions($newWidth, $newHeight, $option) {
			switch ($option) {
				case 'exact': {
					$optimalWidth = $newWidth;
					$optimalHeight = $newHeight;
					break;
				}

				case 'portrait': {
					$optimalWidth = $this->getSizeByFixedHeight( $newHeight );
					$optimalHeight = $newHeight;
					break;
				}

				case 'landscape': {
					$optimalWidth = $newWidth;
					$optimalHeight = $this->getSizeByFixedWidth( $newWidth );
					break;
				}

				case 'auto': {
					$optionArray = $this->getSizeByAuto( $newWidth, $newHeight );
					$optimalWidth = $optionArray['optimalWidth'];
					$optimalHeight = $optionArray['optimalHeight'];
					break;
				}

				case 'crop': {
					$optionArray = $this->getOptimalCrop( $newWidth, $newHeight );
					$optimalWidth = $optionArray['optimalWidth'];
					$optimalHeight = $optionArray['optimalHeight'];
				}
			}

			return array( 'optimalWidth' => $optimalWidth, 'optimalHeight' => $optimalHeight );
		}

		function getSizeByFixedHeight($newHeight) {
			$ratio = $this->width / $this->height;
			$newWidth = $newHeight * $ratio;
			return $newWidth;
		}

		function getSizeByFixedWidth($newWidth) {
			$ratio = $this->height / $this->width;
			$newHeight = $newWidth * $ratio;
			return $newHeight;
		}

		function getSizeByAuto($newWidth, $newHeight) {
			if ($this->height < $this->width) {
				$optimalWidth = $newWidth;
				$optimalHeight = $this->getSizeByFixedWidth( $newWidth );
			} else {
				if ($this->width < $this->height) {
					$optimalWidth = $this->getSizeByFixedHeight( $newHeight );
					$optimalHeight = $newHeight;
				} else {
					if ($newHeight < $newWidth) {
						$optimalWidth = $newWidth;
						$optimalHeight = $this->getSizeByFixedWidth( $newWidth );
					} else {
						if ($newWidth < $newHeight) {
							$optimalWidth = $this->getSizeByFixedHeight( $newHeight );
							$optimalHeight = $newHeight;
						} else {
							$optimalWidth = $newWidth;
							$optimalHeight = $newHeight;
						}
					}
				}
			}

			return array( 'optimalWidth' => $optimalWidth, 'optimalHeight' => $optimalHeight );
		}

		function getOptimalCrop($newWidth, $newHeight) {
			$heightRatio = $this->height / $newHeight;
			$widthRatio = $this->width / $newWidth;

			if ($heightRatio < $widthRatio) {
				$optimalRatio = $heightRatio;
			} else {
				$optimalRatio = $widthRatio;
			}

			$optimalHeight = $this->height / $optimalRatio;
			$optimalWidth = $this->width / $optimalRatio;
			return array( 'optimalWidth' => $optimalWidth, 'optimalHeight' => $optimalHeight );
		}

		function crop($optimalWidth, $optimalHeight, $newWidth, $newHeight) {
			$cropStartX = $optimalWidth / 2 - $newWidth / 2;
			$cropStartY = $optimalHeight / 2 - $newHeight / 2;
			$crop = $this->imageResized;
			$this->imageResized = imagecreatetruecolor( $newWidth, $newHeight );
			imagecopyresampled( $this->imageResized, $crop, 0, 0, $cropStartX, $cropStartY, $newWidth, $newHeight, $newWidth, $newHeight );
		}

		function saveImage($savePath, $imageQuality = '100') {
			$extension = strrchr( $savePath, '.' );
			$extension = strtolower( $extension );
			switch ($extension) {
				case '.jpg': {
				}

				case '.jpeg': {
					if (imagetypes(  ) & IMG_JPG) {
						imagejpeg( $this->imageResized, $savePath, $imageQuality );
					}

					break;
				}

				case '.gif': {
					if (imagetypes(  ) & IMG_GIF) {
						imagegif( $this->imageResized, $savePath );
					}

					break;
				}

				case '.png': {
					$scaleQuality = round( $imageQuality / 100 * 9 );
					$invertScaleQuality = 9 - $scaleQuality;

					if (imagetypes(  ) & IMG_PNG) {
						imagepng( $this->imageResized, $savePath, $invertScaleQuality );
					}

					break;
				}

				default: {
					break;
				}
			}

			imagedestroy( $this->imageResized );
		}
	}

?>